DisplayTrace("Kupyansk");
DisplayTrace("An In the Tracks of the Panzers Mission");
DisplayTrace("By LouisXIV");
---------------------------------------------------------------------------
function RevealObjective0()
--  	Display the briefing
	ObjectiveChanged(0, 0);
	Suicide();
end;

function Objective0()
-- 	Remove the briefing and go to next objective
	ObjectiveChanged(0, 1);
	RunScript( "Objective1", 16000);
	RunScript( "RevealObjective1", 1000);
	Suicide();
end;
---------------------------------------------------------------------------
function RevealObjective1()
-- 	Display technical notes
	ObjectiveChanged(1, 0);
	Suicide();
end;

function Objective1()
--	Remove technical notes and go on to next objective
	ObjectiveChanged(1, 1);
	RunScript( "RevealObjective2", 2000);
	Suicide();
end;
---------------------------------------------------------------------------
function RevealObjective2()
-- 	Show main objective - defeat final Soviet tank attack
	ObjectiveChanged(2, 0);
	Suicide();
end;

function Objective2()
--	If main Russian attack is defeated, win game
-- 	Not triggered until resupply of panzergruppe is started and Russian main attack tanks are landed
	if ( GetNUnitsInScriptGroup(401, 1) <= 0) then
		SetIGlobalVar("GameObjective2", 1);
		ObjectiveChanged(2, 1);
		Win(0);
		Suicide();
	end;
end;
---------------------------------------------------------------------------
function TrainIn()
-- 	After 10 minutes, run a train thru the battlefield just to make some extra interest
--	Land the train here
	LandReinforcement(601);
	RunScript("TrainRun",2000);
	Suicide();
end;

function TrainRun()
--	Run the train here
	GiveCommand(0,601,14042,4616);
	RunScript("CheckTrain",6000);
	Suicide();
end;

function CheckTrain()
--	Check to see if train has reached the end of the line.  If it has, remove it.
	if (GetNScriptUnitsInArea(601,"TrainStop") >= 1) then
		DeleteReinforcement(601);
		Suicide();
	end;
end;
---------------------------------------------------------------------------
function Patrols1()
-- 	Set three squads patrolling back and forth across the map so that they are bound to intercept the convoy.
	GiveCommand(3,10,6738,97);
	GiveQCommand(3,10,6738,13994);
	GiveCommand(3,11,6738,97);
	GiveQCommand(3,11,6738,13994);
	GiveCommand(3,12,6738,97);
	GiveQCommand(3,12,6738,13994);
	RunScript("Patrols2",9000);
	Suicide();
end;

function Patrols2()
--	Check to see if each patrol squad has reached its base point, then start it patrolling again.
	if (GetNScriptUnitsInArea(10,"Patrol") >= 1) then
		GiveCommand(3,10,6738,97);
		GiveQCommand(3,10,6738,13994);
	end;		
	if (GetNScriptUnitsInArea(11,"Patrol") >= 1) then
		GiveCommand(3,11,6738,97);
		GiveQCommand(3,11,6738,13994);
	end;		
	if (GetNScriptUnitsInArea(12,"Patrol") >= 1) then
		GiveCommand(3,12,6738,97);
		GiveQCommand(3,12,6738,13994);
	end;		
end;
---------------------------------------------------------------------------
function Wanderer()
--	Set several squads to randomly wandering around the map
	GiveQCommand(3,50,((RandomInt(10) + 2) * 1000),((RandomInt(10) + 2) * 1000));
end;
---------------------------------------------------------------------------
function Chek4Supply()
--	Check to see if officer has made it to the tank defense area
	if GetNScriptUnitsInArea(1000,"Laager") >= 1 then
--	Bring on the Soviet tanks
		LandReinforcement(401);
-- 	Give the Germans a supply base
		LandReinforcement(1300);
-- 	Start main objecive running
		RunScript( "Objective2", 4000);
--	Start Soviet tanks moving
		RunScript("Move401",4000);
		Suicide();
	end;
end;
---------------------------------------------------------------------------
function Move401()
--	Move Soviet tanks to one of three random locations in preparation for attack
	GiveCommand(3,401,7000,((RandomInt(3) * 5000) - 4000));
--	Send Soviet tanks in to the attack
	GiveQCommand(3,401,13600,8400);
	Suicide();
end;
---------------------------------------------------------------------------
function Angriff()
--	Pick a random number 1-8
	z = RandomInt(8);
--	If random number matches a reinforcment group, land and send the group
	if z == 1 then
		LandReinforcement(20);
		RunScript("A20",4000);
	end;
	if z == 2 then
		LandReinforcement(40);
		RunScript("A20",4000);
	end;
	if z == 3 then
		LandReinforcement(60);
		RunScript("A20",4000);
	end;
	if z == 4 then
		LandReinforcement(80);
		RunScript("A20",4000);
	end;	
end;

function A20()
--	Send all the groups in to attack German tanks
	GiveCommand(3,20,13600,8400);
	GiveCommand(3,40,13600,8400);
	GiveCommand(3,60,13600,8400);
	GiveCommand(3,80,13600,8400);
	Suicide();
end;
---------------------------------------------------------------------------
function A501()
--	Run convoy of Soviet trucks
	GiveCommand(0,501,7515,7906);
	GiveQCommand(0,501,75,6958);
	GiveCommand(0,502,7515,7906);
	GiveQCommand(0,502,75,6958);
	GiveCommand(0,503,7515,7906);
	GiveQCommand(0,503,75,6958);
	GiveCommand(0,504,7515,7906);
	GiveQCommand(0,504,75,6958);
	GiveCommand(0,505,7515,7906);
	GiveQCommand(0,505,75,6958);
	RunScript("B501",1000);
	Suicide();
end;

function B501()
--	If the first Soviet truck in convoy is destroyed.
	if GetNUnitsInScriptGroup(501,1) <= 0 then
--	Find the location of the third truck
		x,y = GetObjCoord(502);
-- 	Have the rest of the trucks deposit their troops at that location		
		GiveCommand(5,502,x,y);
		GiveCommand(5,503,x,y);
		GiveCommand(5,504,x,y);
		GiveCommand(5,505,x,y);
--	Have the trucks retire back to from where the came
		GiveQCommand(0,502,13500,13500);
		GiveQCommand(0,503,13550,13500);
		GiveQCommand(0,504,13500,13550);
		GiveQCommand(0,505,13550,13550);
		RunScript("C501",4000);
		Suicide();
	end;
end;

function C501()
--	Have the deposited troops attack westward
	GiveCommand(3,512,75,6958);
	Suicide();
end;
---------------------------------------------------------------------------
function TobeDefeated()
--	If the officer (ScriptID 1000) is killed
	if ( GetNUnitsInScriptGroup(1000, 0) <= 0) then
--	You lose
		Loose();
		Suicide();
	end;
	if ( GetNUnitsInScriptGroup(1100, 0) <= 0) then
--	If the supply trucks are all destroyed you lose
		Loose();
		Suicide();
	end;
	if ( GetNUnitsInScriptGroup(1110, 0) <= 0) then
--	If the repair trucks are all destroyed you lose
		Loose();
		Suicide();
	end;
	if ( GetNUnitsInScriptGroup(1200, 0) <= 0) then
--	If the German tanks are all destroyed you lose
		Loose();
		Suicide();
	end;
end;
---------------------------------------------------------------------------
function Init()
	RunScript( "Objective0", 16000);
	RunScript( "RevealObjective0", 1000);
	RunScript( "TobeDefeated", 4000);
	RunScript("TrainIn",600000);
	RunScript("Patrols1",4000);
-- 	Start the "Lost Patrol" wandering
	GiveCommand(3,50,((RandomInt(10) + 2) * 1000),((RandomInt(10) + 2) * 1000));
	RunScript("Wanderer",120000);
	RunScript("Chek4Supply",9000);
	RunScript("Angriff",60000);
	LandReinforcement(501);
	RunScript("A501",20000);
	GiveCommand(3,301,75,6958);
	GiveQCommand(3,301,13600,8400);
end;
