DisplayTrace("Stalingrad 1942");
DisplayTrace("An In the Tracks of the Panzers Mission");
DisplayTrace("By LouisXIV");
------------------------------------------------------------
function StartThingsOff()
	SetIGlobalVar("Minuta", 0) -- Set the initial value
	SetIGlobalVar("Hora", 0) -- Set the initial value
	-- This is the first unit of artillery being landed
	LandReinforcement(2400);
	RunScript("BoatArriving",360000);  -- Infantry reinforcements
	RunScript("Check2401",900000);  
	RunScript("Land2411",900000);  -- Landing second group of Soviet artillery
	Suicide();
end;

function Check2401()
	-- Checking to see if artillery or AA needs replacement
	if GetNUnitsInScriptGroup(2401,1) <= 0 then
		LandReinforcement(2401);
	end;
	if GetNUnitsInScriptGroup(2402,1) <= 0 then
		LandReinforcement(2402);
	end;
	if GetNUnitsInScriptGroup(2403,1) <= 0 then
		LandReinforcement(2403);
	end;
end;
------------------------------------------------------------
function BoatArriving()
	-- These are the USSRRifle39 - 2 squads - arriving at the ferry landing stage
	LandReinforcement(2201);
	RunScript("NoobieSuicide",2000);
end;

function NoobieSuicide()
	-- They are given the coordinates of the nearest German infantry unit and told to attack
	x,y = GetObjCoord(1000);
	GiveCommand(3,2201,x,y);
	Suicide();
end;
------------------------------------------------------------
function Land2411()
	-- Landing second group of Soviet artillery
	LandReinforcement(2410);
	RunScript("Check2411",900000);
	RunScript("Land2421",900000);
	Suicide();
end;

function Check2411()
	-- Checking to see if second group of artillery or AA needs replacement
	if GetNUnitsInScriptGroup(2411,1) <= 0 then
		LandReinforcement(2411);
	end;
	if GetNUnitsInScriptGroup(2412,1) <= 0 then
		LandReinforcement(2412);
	end;
	if GetNUnitsInScriptGroup(2413,1) <= 0 then
		LandReinforcement(2413);
	end;
end;
------------------------------------------------------------
function Land2421()
	-- Landing third group of Soviet artillery
	LandReinforcement(2420);
	RunScript("Check2421",900000);
	RunScript("Land2431",900000);
	Suicide();
end;

function Check2421()
	-- Checking to see if third group of artillery or AA needs replacement
	if GetNUnitsInScriptGroup(2421,1) <= 0 then
		LandReinforcement(2421);
	end;
	if GetNUnitsInScriptGroup(2422,1) <= 0 then
		LandReinforcement(2422);
	end;
	if GetNUnitsInScriptGroup(2423,1) <= 0 then
		LandReinforcement(2423);
	end;
end;
------------------------------------------------------------
function Land2431()
	LandReinforcement(2430);
	RunScript("Check2431",900000);
	Suicide();
end;

function Check2431()
	if GetNUnitsInScriptGroup(2431,1) <= 0 then
		LandReinforcement(2431);
	end;
	if GetNUnitsInScriptGroup(2432,1) <= 0 then
		LandReinforcement(2432);
	end;
	if GetNUnitsInScriptGroup(2433,1) <= 0 then
		LandReinforcement(2433);
	end;
end;
------------------------------------------------------------
function RevealObjective0()
	ObjectiveChanged(0, 0);
	Suicide();
end;

function Objective0()
	ObjectiveChanged(0, 1);
	Suicide();
end;
------------------------------------------------------------
function RevealObjective1()
	ObjectiveChanged(1, 0);
	Suicide();
end;

function Objective1()
	if ( GetNScriptUnitsInArea(1000,"TraktorFaktory") >= 3) then
		SetIGlobalVar("GameObjective1", 1);
		ObjectiveChanged(1, 1);
		Suicide();
	end;
end;
------------------------------------------------------------
function RevealObjective2()
	ObjectiveChanged(2, 0);
	Suicide();
end;

function Objective2()
	if ( GetNScriptUnitsInArea(1000,"RedOktoberWerks") >= 3) then
		SetIGlobalVar("GameObjective2", 1);
		ObjectiveChanged(2, 1);
		Suicide();
	end;
end;
------------------------------------------------------------
function RevealObjective3()
	ObjectiveChanged(3, 0);
	Suicide();
end;

function Objective3()
	ObjectiveChanged(3, 1);
	Suicide();
end;
------------------------------------------------------------
function Objective4()
	ObjectiveChanged(4, 1);
	Suicide();
end;
------------------------------------------------------------
function NewTank()
	-- Landing T-34 at the Traktor Faktory if the Traktor Faktory still exists
	if GetObjectHPs(9000) <= 0 then
		Suicide();
	end;
	LandReinforcement(2000);
	RunScript("RunTank",4000);
end;

function RunTank()
	x,y = GetObjCoord(1000);
	GiveCommand(3,2000,x,y);
	Suicide();
end;
------------------------------------------------------------
function Set0()
	SetIGlobalVar("Counter.1001", 1) -- Set the initial value
	Suicide();
end;

function AddUp1001()
	Count1001 = GetIGlobalVar("Counter.1001", 0)
	if (Count1001 <= 3) then
		Count1001 = Count1001 + 1
	end;
	SetIGlobalVar("Counter.1001", Count1001)
	if (Count1001 <= 3) then
		RunScript( "Repeat1001", 300000);
		Suicide();
	end;
end;

function Repeat1001()
	if (GetNUnitsInScriptGroup(1001, 0) < 1) then
		RunScript( "Reinf1001", 3000);
		Suicide();
	end;
end;

function Reinf1001()
	LandReinforcement(1001)
	RunScript( "AddUp1001", 18000);
	Suicide();
end;
------------------------------------------------------------
function ToWin()
	RunScript("Objective3",1000);
	RunScript("Objective4",5000);
	Win(0);
	Suicide();
end;

function Phenomenal()
	if ( (GetIGlobalVar("GameObjective1", 0) * GetIGlobalVar("GameObjective2", 0)) == 1) then
		DisplayTrace("Fantastic! You have achieved your objectives despite the worst opposition!");
		RunScript("Objective3",1000);
		Win(0);
		Suicide();
	end;
end;

function TobeDefeated()
	if ( GetNUnitsInScriptGroup(1000, 0) <= 0) then
		Loose();
		Suicide();
	end;
end;
------------------------------------------------------------
function StgTimer()
	SetIGlobalVar("Minuta",(GetIGlobalVar("Minuta",0) + 1));
	if GetIGlobalVar("Minuta",0) > 59 then
		SetIGlobalVar("Minuta",0);
		SetIGlobalVar("Hora",(GetIGlobalVar("Hora",0) + 1));
	end;
	DisplayTrace("Time is %g Hours and %g Minutes", GetIGlobalVar("Hora",0),GetIGlobalVar("Minuta",0));
end;
------------------------------------------------------------
function Init()
	RunScript("StartThingsOff",2000);
	RunScript("NewTank",600000);
	RunScript( "RevealObjective0", 1000);
	RunScript( "Objective0", 16000);
	RunScript( "RevealObjective1", 17000);
	RunScript( "Objective1", 40000);
	RunScript( "RevealObjective2", 22000);
	RunScript( "Objective2", 40000);
	RunScript( "RevealObjective3", 27000);
	RunScript( "ToWin", 3600000);
	RunScript("Phenomenal",12000);
	RunScript( "TobeDefeated", 4000);
	RunScript( "Set0", 3000);
	RunScript( "Reinf1001", 3000);
	RunScript("StgTimer",60000);
end;
